package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.InfernalMobs
import io.github.thehrz.infernalmobs.handler.EffectHandle
import io.github.thehrz.infernalmobs.utils.MathUtils
import org.bukkit.entity.Ageable
import org.bukkit.entity.LivingEntity
import org.bukkit.entity.Player
import org.bukkit.entity.Sheep
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityBreedEvent
import org.koin.core.annotation.Single

@Single
class EntityBreedListener(
    val plugin: InfernalMobs,
    val effectHandle: EffectHandle
) : Listener {
    @EventHandler
    fun onEntityBreed(e: EntityBreedEvent) {
        if (e.breeder is Player) {
            val p = e.breeder as Player?
            if (effectHandle.fertileList.contains(p)) {
                for (i in 0 until MathUtils.rand(1, 4)) {
                    val babe = e.entity.location.world.spawnEntity(e.entity.location, e.entityType) as LivingEntity
                    if (babe is Ageable) babe.setBaby()
                    if (e.entity is Sheep) (babe as Sheep).color = (e.entity as Sheep).color
                }
            }
        }
    }
}