package io.github.thehrz.infernalmobs.listeners

import org.bukkit.entity.Player
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerQuitEvent
import org.bukkit.plugin.java.JavaPlugin
import org.koin.core.annotation.Single

@Single
class PlayerQuitListener() : Listener {
    var levitateList = mutableListOf<Player>()

    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerQuit(e: PlayerQuitEvent) {
        val p = e.player
        if (levitateList.contains(p)) {
            p.allowFlight = false
            levitateList.remove(p)
        }
    }
}