package io.github.thehrz.infernalmobs.utils

import org.bukkit.Location
import org.bukkit.Particle
import org.bukkit.World
import java.util.*

object ParticleUtils {
    fun displayParticle(
        effect: String?,
        w: World,
        x: Double,
        y: Double,
        z: Double,
        radius: Double,
        speed: Int,
        amount: Int
    ) {
        var amount = amount
        amount = if ((amount <= 0)) 1 else amount
        val l = Location(w, x, y, z)
        try {
            if (radius <= 0) {
                w.spawnParticle(Particle.valueOf(effect!!), l, 0, 0.0, 0.0, speed.toDouble(), amount.toDouble())
            } else {
                val ll = LocationUtils.getArea(l, radius, 0.2)
                if (ll.size > 0) {
                    for (i in 0 until amount) {
                        val index = Random().nextInt(ll.size)
                        w.spawnParticle(Particle.valueOf(effect!!), ll[index]!!, 1, 0.0, 0.0, 0.0, 0.0)
                        ll.removeAt(index)
                    }
                }
            }
        } catch (ex: Exception) {
            // System.out.println("V: " + getServer().getVersion());
            // ex.printStackTrace();
        }
    }

    fun displayParticle(effect: String, l: Location, radius: Double, speed: Int, amount: Int) {
        displayParticle(effect, l.world, l.x, l.y, l.z, radius, speed, amount)
    }
}