package io.github.thehrz.infernalmobs.utils

import org.bukkit.entity.Entity
import org.bukkit.entity.Player
import org.bukkit.util.BlockIterator

object PlayerUtils {
    fun getTarget(player: Player): Entity? {
        val iterator = BlockIterator(
            player.world, player
                .location.toVector(), player.eyeLocation
                .direction, 0.0, 100
        )
        while (iterator.hasNext()) {
            val item = iterator.next()
            for (entity in player.getNearbyEntities(100.0, 100.0, 100.0)) {
                val acc = 2
                for (x in -acc until acc) for (z in -acc until acc) for (y in -acc until acc) if (entity.location.block
                        .getRelative(x, y, z) == item
                ) {
                    return entity
                }
            }
        }
        return null
    }
}