package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.player.PlayerChangedWorldEvent
import org.koin.core.annotation.Single

@Single
class PlayerChangedWorldLIstener(
    val infernalMobService: InfernalMobService
) {
    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerChangedWorld(event: PlayerChangedWorldEvent) {
        val world = event.player.world
        infernalMobService.giveMobsPowers(world)
    }
}