package io.github.thehrz.infernalmobs.listeners

import io.github.thehrz.infernalmobs.services.InfernalMobService
import org.bukkit.event.EventHandler
import org.bukkit.event.EventPriority
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerTeleportEvent
import org.koin.core.annotation.Single

@Single
class PlayerTeleportListener(val infernalMobService: InfernalMobService): Listener {
    @EventHandler(priority = EventPriority.HIGH)
    fun onPlayerTeleport(event: PlayerTeleportEvent) {
        val world = event.player.world
        infernalMobService.giveMobsPowers(world)
    }
}